package com.perforce.maven.scm.provider.p4.command.export;

/*
 * Copyright (c) 2010 Perforce Software. All rights reserved.
 */

import java.io.File;

import org.apache.maven.scm.ScmFileSet;
import org.apache.maven.scm.ScmVersion;
import org.apache.maven.scm.command.checkout.CheckOutScmResult;
import org.apache.maven.scm.command.export.ExportScmResult;
import org.apache.maven.scm.repository.ScmRepository;
import org.apache.maven.scm.tck.command.checkout.CheckOutCommandTckTest;
import org.codehaus.plexus.util.FileUtils;

import com.perforce.maven.scm.provider.p4.P4ScmTestUtils;

public class P4ExportCommandTckTest
    extends CheckOutCommandTckTest
{

    /** {@inheritDoc} */
    public String getScmUrl()
        throws Exception
    {
        return P4ScmTestUtils.getScmUrl();
    }

    /** {@inheritDoc} */
    public void initRepo()
        throws Exception
    {
        P4ScmTestUtils.initRepo();
        resetToOrignalFiles();
    }

    private void resetToOrignalFiles()
        throws Exception
    {
        //use export to test initialize the checkout
        export( getWorkingCopy(), getScmRepository() );
        ScmFileSet fileSet = new ScmFileSet( getWorkingCopy(), P4ScmTestUtils.getAddedIncludes(), null );
        getScmManager().getProviderByUrl( getScmUrl() ).remove( getScmRepository(), fileSet,
                                                                "Remove previous test files" );
        fileSet = new ScmFileSet( getWorkingDirectory(), P4ScmTestUtils.getTestIncludes(), null );
        getScmManager().getProviderByUrl( getScmUrl() ).edit( getScmRepository(), fileSet );
        P4ScmTestUtils.populateOriginalData( getBasedir(), getWorkingCopy() );
        checkIn( getWorkingCopy(), getScmRepository() );
        FileUtils.deleteDirectory( getWorkingDirectory() );

    }

    public void testSecondCheckoutUsingTheSameSpec()
        throws Exception
    {
        CheckOutScmResult result = checkOut( getWorkingCopy(), getScmRepository() );
        //fix me check for file count
    }

    /**
     * Convenience method to check out files from the repository
     */
    private ExportScmResult export( File workingDirectory, ScmRepository repository )
        throws Exception
    {
        ExportScmResult result =
            getScmManager().getProviderByUrl( getScmUrl() ).export( repository, new ScmFileSet( workingDirectory ),
                                                                      (ScmVersion) null );

        assertTrue( "Check result was successful, output: " + result.getCommandOutput(), result.isSuccess() );

        return result;
    }
}
